/*
 * RadRead monitors the pulses generated by a Radalert Inspector from Medcom.
 * Copyright (c) 2002-2009, ir. Hans Lambermont, M.Sc.
 * License: GPL. See http://www.opensource.org/licenses/gpl-license.php
 * $Id: radread.c,v 1.5 2007/06/24 13:02:16 hans Exp $
 */
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
/* FreeBSD microseconds */
#include <sys/time.h>
#include <termios.h>

#define SERIALPORT "/dev/cuad1"

int main(int argc, char **argv) {
	ssize_t retval;
	unsigned char a;
	struct tm *ptm;
	struct timeval tval; /* long tv_sec; long tv_usec;*/
	struct timezone tzone;
	struct termios t;
	int fd = open(SERIALPORT, O_RDONLY | O_DIRECT);
	if (fd == -1) {
		fprintf(stderr, "Error %d opening SERIALPORT : %s\n",
				errno, strerror(errno));
		return 1;
	}
	tcgetattr(fd, &t);            /* get current terminal state */
	cfmakeraw(&t);                /* set terminal state to raw I/O path */
	t.c_cflag |= CLOCAL;          /* ignore modem status lines */
	t.c_cc[VMIN] = 1;             /* set default noncanonical mode */
	t.c_cc[VTIME] = 0;            /* set default noncanonical mode */
	tcsetattr(fd, TCSAFLUSH, &t); /* set updated terminal state */
	setbuf(stdout, NULL); /* disable printf buffering */
	while(1) {
		retval=read(fd, &a, 1); /* block until +5V pulse is read */
		if (retval == 1) {
			gettimeofday(&tval, &tzone);
			ptm=gmtime((const time_t *)&tval.tv_sec);
			printf("%4d-%0.2d-%0.2d %0.2d:%0.2d %0.2d.%0.6ld\n",
				   ptm->tm_year + 1900, ptm->tm_mon + 1, ptm->tm_mday,
				   ptm->tm_hour, ptm->tm_min,
				   ptm->tm_sec, tval.tv_usec);
		} else {
			if (retval == 0) {
				fprintf(stderr, "end-of-file\n");
			} else {
				int *perr = __error();
				fprintf(stderr, "Error %d\n", *perr);
			}
		}
	}
	close(fd);
	return 0;
}

